package Device_2
  with SPARK_Mode,
       Abstract_State => (State with External => (Async_Readers,
                                                  Async_Writers,
                                                  Effective_Reads)),
       Initializes    => State
is
   procedure Write (X : in Integer)
     with Global  => (In_Out => State),
         Depends => (State =>+ X);

   procedure ReadAck (OK : out Boolean)
     with Global  => (In_Out => State),
          Depends => ((OK, State) => State);

   function Last_Written return Integer
     with Global => State;

end Device_2;
