pragma SPARK_Mode;
package body Initial_Condition_Example
  with Refined_State => (Stack => (Vector, Pointer))
is
   Stack_Size : constant := 100;
   type Pointer_Range is range 0 .. Stack_Size;
   subtype Vector_Range is Pointer_Range range 1 .. Stack_Size;

   Vector : array (Vector_Range) of Integer;
   Pointer : Pointer_Range;

   function Stack_Empty return Boolean is (Pointer = 0)
     with Refined_Global => Pointer;

   function Stack_Full return Boolean is (Pointer = Stack_Size)
     with Refined_Global => Pointer;

   procedure Push (X : in Integer)
     with Refined_Global => (In_Out => (Vector, Pointer))
   is
   begin
      Pointer := Pointer + 1;
      Vector (Pointer) := X;
   end Push;

   procedure Pop (X : out Integer)
     with Refined_Global => (Input => Vector, In_Out => Pointer)
   is
   begin
      X := Vector (Pointer);
      Pointer := Pointer - 1;
   end Pop;
begin
   Pointer := 0;
   Vector := (others => 0);

end Initial_Condition_Example;
