pragma SPARK_Mode;
package Initial_Condition_Example
  with Abstract_State => Stack,
       Initializes => Stack,
       Initial_Condition => Stack_Empty
is

   function Stack_Empty return Boolean
     with Global => Stack;

   function Stack_Full return Boolean
     with Global => Stack;

   procedure Push (X : in Integer)
     with Global => (In_Out => Stack),
          Pre    => not Stack_Full;

   procedure Pop (X : out Integer)
     with Global => (In_Out => Stack),
          Pre    => not Stack_Empty;

end Initial_Condition_Example;
