pragma SPARK_Mode;
with System.Storage_Elements;

package body Serial_Port
  with Refined_State =>
       (Input_Port => Port_23)
is

   Port_23 : Integer
     with Volatile,
          Async_Writers,
          Effective_Reads,
          Address => System.Storage_Elements.To_Address (16#A11CAF0#);

   procedure Read_Port (X1, X2 : out Integer; Y : in Boolean)
     with Refined_Global  => (In_Out => Port_23),
          Refined_Depends => (
                              X1      => (Port_23, Y),
                              X2      => (Port_23), -- adding and removing Y makes no difference
                              Port_23 => (Port_23, Y))
   is
   begin
      if Y then
         X1 := Port_23;
      end if;
      X1 := 0; -- this doesn't raise an error either, so flow analysis is not running
      X2 := Port_23;
   end Read_Port;

end Serial_Port;
