pragma SPARK_Mode;
package body Stack
with Refined_State => (The_Stack => (Vector, Pointer))
is
   Stack_Size : constant := 100;
   Vector : array (1 .. Stack_Size) of Integer;
   Pointer : Integer;

   procedure Push (X : in Integer)
     with Refined_Global  => (In_Out => (Vector, Pointer)),
          Refined_Depends => (Pointer => Pointer,
                              Vector  => (Vector, Pointer, X))
   is
   begin
      Pointer := Pointer + 1;
      Vector (Pointer) := (X);
   end Push;

   procedure Pop (X : out Integer)
     with Refined_Global  => (In_Out => Pointer,
                              Input  => Vector),
          Refined_Depends => (Pointer  => Pointer,
                              X        => (Pointer, Vector))
   is
   begin
      X := Vector (Pointer);
      Pointer := Pointer - 1;
   end Pop;

end Stack;
