package Pre_Post_Exercise is

   Stack_Size : constant := 100;
   type Pointer_Range is range 0 .. Stack_Size;
   subtype Stack_Range is Pointer_Range range 1 .. Stack_Size;
   Stack : array (Stack_Range) of Integer;
   Stack_Pointer : Pointer_Range := 0;

   function Is_Full return Boolean is (Stack_Pointer = Stack_Size)
   with Global => (Input => Stack_Pointer);

   function Is_Empty return Boolean is (Stack_Pointer = 0)
   with Global => Stack_Pointer;

   procedure Initialize
     with Global  => (Output => (Stack,
                                 Stack_Pointer)),
          Post    => Is_Empty;

   procedure Push (X : in Integer)
     with Global  => (In_Out => (Stack, Stack_Pointer)),
          Pre     => not Is_Full;

   procedure Pop (X : out Integer)
     with Global  => (In_Out => Stack_Pointer,
                      Input  => Stack),
          Pre     => not Is_Empty;

end Pre_Post_Exercise;
