package body Isqrt
is

   function Find_Int_Sqrt (N : in Natural) return Natural
   is
      Lower, Upper, Middle: Natural;
      Maximum_Root: constant Natural := 46341; -- assumes Natural'Last = 2**31-1.
   begin
      Lower := 0;

      if N >= Maximum_Root then
	 Upper := Maximum_Root;
      else
	 Upper := N + 1;
      end if;

      loop
         --  Add a pragma Loop_Invariant and a pragma Loop_Variant here.
         pragma Loop_Invariant (Lower * Lower <= N and N < Upper * Upper and
                                  Upper <= Maximum_Root);
         pragma Loop_Variant(Decreases => Upper - Lower);

	 exit when Lower + 1 = Upper;
	 Middle := (Lower + Upper) / 2;
	 if Middle * Middle > N then
	    Upper := Middle;
	 else
	    Lower := Middle;
	 end if;
      end loop;
      return Lower;
   end Find_Int_Sqrt;

end Isqrt;
