package body Max is

   function Arrays_Max (A : in Our_Array) return Index_Range is
      X : Index_Range := Index_Range'First;
      Y : Index_Range := Index_Range'Last;

      function Max (E1, E2 : Content_Range) return Content_Range
      is (if E1 <= E2 then E2 else E1) with Ghost;

   begin
      while X /= Y loop

         pragma Loop_Invariant
           ((for all N in Index_Range'First .. X  => Max(A(X), A(Y)) >= A (N)) and
              (for all N in Y .. Index_Range'Last   => Max(A(X), A(Y)) >= A (N)) and
                X < Y);

         pragma Loop_Variant (Decreases => Y - X);

         if A (X) <= A (Y) then
            X := X + 1;
         else
            Y := Y - 1;
         end if;
      end loop;
      return X;
   end Arrays_Max;

end Max;
