with Ada.Containers; use Ada.Containers;

package Int_Set_Types
  with SPARK_Mode,
       Pure
is
   -- We require a constrained type so that doubling does not cause an overflow
   type Signed_Type is new Integer range -100 .. 100;

   -- Hash type is a large modulo number and must be non-negative.
   -- For this example a suitable value for the function result is
   -- Signed_Type'Last - Signed_Type'First + 1
   function Hash (Id : Signed_Type) return Hash_Type is
     (Hash_Type ((Id - Signed_Type'First + 1)));

   function Equivalent_Elements (I1, I2 : Signed_Type) return Boolean is
     (I1 = I2);

   function My_Equal (I1, I2 : Signed_Type) return Boolean is (I1 = I2);

end Int_Set_Types;
