with Ada.Containers; use Ada.Containers;

with Int_Set_Types;  use Int_Set_Types;
with Int_Sets;       use Int_Sets;

package Signed_Ops with
  SPARK_Mode
is
   Set_Size : constant Count_Type := 100;

   subtype My_Set is Int_Sets.Set (Capacity => Set_Size,
                                   Modulus  => Default_Modulus (Set_Size));

   function Double_All (S : My_Set) return My_Set with
     Global => null,
     Pre  => (for all E of S => E in -50 .. 50),
     Post => (for all E of S => Contains (Double_All'Result, 2 * E));

   function Make_All_Positive (S : My_Set) return My_Set with
     Global => null,
     Post => (for all E of S => Contains (Make_All_Positive'Result, abs E));

end Signed_Ops;
