with Ada.Containers;         use Ada.Containers;

with Needed_For_Formal_Sets; use Needed_For_Formal_Sets;
with My_Sets;                use My_Sets;

package Use_My_Sets with
  SPARK_Mode
is
   Set_Size : constant Count_Type := Count_Type (Element_Type'Last);

   subtype My_Set is My_Sets.Set (Capacity => Set_Size,
                                  Modulus  => Default_Modulus (Set_Size));

   function Double_All (S : My_Set) return My_Set with
     Pre  => (for all E of S => E in -50 .. 50),
     Post => (for all E of S => Contains (Double_All'Result, 2 * E));

end Use_My_Sets;
