package body Crypto
  with SPARK_Mode,
       Refined_State => (Key_Store => null)
is

   use type Interfaces.C.int;

   procedure Load_Key
     (The_Key  : in  Key_Slot;
      Key_Data : in  Key;
      Success  : out Boolean)
   with
      SPARK_Mode => Off
   is
      function Local_Load_Key (The_Key  : in Key_Slot;
                               Key_Data : in Key)
                               return Interfaces.C.Int
      with Import,
           Convention => C,
           External_Name => "loadkey";
   begin
      Success := Local_Load_Key (The_Key, Key_Data) = 0;
   end Load_Key;

   procedure Encrypt
     (The_Key  : in     Key_Slot;
      The_Data : in out Data;
      Success  :    out Boolean)
   with
      SPARK_Mode => Off
   is
      function Local_Encrypt (The_Key  : in     Key_Slot;
                              The_Data : in out Data)
                              return Interfaces.C.Int
      with Import,
           Convention => C,
           External_Name => "encrypt";
   begin
      Success := Local_Encrypt (The_Key, The_Data) = 0;
   end Encrypt;

end Crypto;
