with Interfaces.C;

package Crypto
  with SPARK_Mode,
       Abstract_State => Key_Store,
       Initializes    => Key_Store
is

   subtype Byte is Interfaces.C.unsigned_char;
   subtype Key_Slot is Interfaces.C.int range 0 .. 3;
   type Key_Index is range 1 .. 128;
   type Key is array (Key_Index) of Byte;
   type Data_Index is range 1 .. 1024;
   type Data is array (Data_Index) of Byte;

   procedure Load_Key
     (The_Key  : in  Key_Slot;
      Key_Data : in  Key;
      Success  : out Boolean) with
     Global => (In_Out => Key_Store);

   procedure Encrypt
     (The_Key  : in     Key_Slot;
      The_Data : in out Data;
      Success  :    out Boolean) with
     Global => (In_Out => Key_Store);

end Crypto;
