package Stacks
  with SPARK_Mode
is
   subtype Item is Integer range 0 .. 20;
   type Stack is private;
   Stack_Size : constant := 100;

   function Is_Empty (S : Stack) return Boolean;
   function Is_Full (S : Stack) return Boolean;
   function Top (S : Stack) return Item with
     Pre => not Is_Empty (S);

   procedure Clear (S :    out Stack) ;

   procedure Push  (S : in out Stack; It : in     Item) with
     Pre  => not Is_Full (S);

   procedure Pop   (S : in out Stack; It :    out Item) with
     Pre  => not Is_Empty (S);

private
   subtype Stack_Pointer is Natural range 0 .. Stack_Size;
   subtype Index is Stack_Pointer range 1 .. Stack_Size;
   type Vector is array (Index) of Item;
   type Stack is record
      P : Stack_Pointer;
      V : Vector;
   end record;
end Stacks;
