with Ada.Containers;         use Ada.Containers;
with Ada.Integer_Text_IO;    use Ada.Integer_Text_IO;

with Needed_For_Formal_Sets; use Needed_For_Formal_Sets;
with My_Sets;                use My_Sets;

package Use_My_Sets
  with SPARK_Mode
is
   Set_Size : constant Count_Type := Count_Type (Element_Type'Last);

   -- Declare a constrained subtype of My_Sets of a given capacity
   subtype My_Set is My_Sets.Set (Capacity => Set_Size,
                                  Modulus  => Default_Modulus (Set_Size));

   function Double_All (S : My_Set) return My_Set with
     Global => null,
     Pre  => (for all E of S => E in -50 .. 50),
     Post => (for all E of S => Contains (Double_All'Result, 2 * E));

end Use_My_Sets;
