with Display;       use Display;
with Display.Basic; use Display.Basic;

procedure Main is

   Red_Piece, Green_Piece : Shape_Id;
   
   --  Logical coordinate system
   X_Size : constant Natural := 8;
   Y_Size : constant Natural := 16;  
   type X_Coord is range 1 .. X_Size;
   type Y_Coord is range 1 .. Y_Size;
   
   --  Pixel constants for graphical components
   Pxl_Width    : constant Natural := 10;
   Pxl_Origin_X : constant Integer := -40;
   Pxl_Origin_Y : constant Integer := 80;
     
begin

   Red_Piece   := New_Box (X      => Float (Pxl_Origin_X),
                           Y      => Float (Pxl_Origin_Y),
                           Width  => Float (Pxl_Width),
                           Height => Float (Pxl_Width),
                           Color  => Red);
   
   Green_Piece := New_Box (Float (Pxl_Origin_X + X_Size * Pxl_Width), 
                           Float (Pxl_Origin_Y - Y_Size * Pxl_Width), 
                           Float (Pxl_Width),
                           Float (Pxl_Width), 
                           Green);
end Main;
