with Ada.Text_IO;   use Ada.Text_IO;
with Display;       use Display;
with Display.Basic; use Display.Basic;

procedure Main is

   --  Logical coordinate system
   X_Size : constant Natural := 8;
   Y_Size : constant Natural := 16;  
   subtype X_Coord is Natural range 1 .. X_Size;
   subtype Y_Coord is Natural range 1 .. Y_Size;
   
   --  Pixel constants for graphical components
   Pxl_Width    : constant Natural := 10;
   Pxl_Origin_X : constant Integer := -40;
   Pxl_Origin_Y : constant Integer := 80;
     
   Falling_Piece : Shape_Id;
   
begin
   
   Falling_Piece := 
     New_Box (X      => Float (Pxl_Origin_X + X_Size / 2 * Pxl_Width),
              Y      => Float (Pxl_Origin_Y),
              Width  => Float (Pxl_Width),
              Height => Float (Pxl_Width),
              Color  => Red);
   
   for Y in Y_Coord loop
      delay 0.2;
      Set_Y (Falling_Piece, Float (Pxl_Origin_Y - Y * Pxl_Width));
   end loop;
   
   Put_Line ("GAME OVER!");

end Main;
