with Ada.Text_IO;   use Ada.Text_IO;
with Tetris;        use Tetris;
with Ada.Numerics.Discrete_Random;

procedure Main 
is
   
   package Random_Piece is 
     new Ada.Numerics.Discrete_Random (Piece_Type);
   use Random_Piece;
   
   Piece_Generator : Random_Piece.Generator;
   Next_Piece_Type : Piece_Type;
   
   Game_Board : Board;
   
   Falling_Piece : Piece;
   
   procedure Print_Board (B : in Board) is 
   begin
      for Y in Y_Coord loop
         for X in X_Coord loop
            Put (if B (Y) (X).Kind = Empty then "- " else 
                    Cell_Type'Image (B (Y) (X).Kind) & " ");   
         end loop;
         Put_Line (" ");
      end loop;
      Put_Line (" ");
   end Print_Board;

begin
   
   Game_Board := New_Board;
   
   Next_Piece_Type := Random (Piece_Generator);
   
   Falling_Piece := New_Piece (Next_Piece_Type);
   
   for Y in Y_Coord loop
      delay 0.2;
      Falling_Piece.Y := Y;
      Update_Graphics (Falling_Piece);
   end loop;
   
   Insert_Piece_In_Board (P => Falling_Piece,
                          B => Game_Board);
   
   Print_Board (Game_Board);
   Put_Line ("GAME OVER!");

end Main;
