with Ada.Text_IO;   use Ada.Text_IO;
with Tetris;        use Tetris;
with Display;       use Display;
with Display.Basic; use Display.Basic;
with Ada.Numerics.Discrete_Random;

procedure Main
is
   
   package Random_Piece is 
     new Ada.Numerics.Discrete_Random (Piece_Type);
   use Random_Piece;
   
   Piece_Generator : Random_Piece.Generator;
   Next_Piece_Type : Piece_Type;
   
   Last_Key : Key_Type;
   Next_Move : User_Action;
   
   Game_Board : Board;
   Falling_Piece : Piece;
   
begin
   
   Game_Board := New_Board;
   
   Next_Piece_Type := Random (Piece_Generator);
   
   Falling_Piece := New_Piece (Next_Piece_Type);
   
   for Y in Y_Coord loop
      delay 0.1;
      
      Last_Key := Current_Key_Press;
      Next_Move := (case To_Special (Last_Key) is
                       when KEY_LEFT => Move_Left,
                       when KEY_RIGHT => Move_Right,
                       when others => Move_None);
      
      Do_Action (Next_Move, Falling_Piece);
      Do_Action (Move_Down, Falling_Piece);
      
      Update_Graphics (Falling_Piece);
      
   end loop;
   
   Insert_Piece_In_Board (P => Falling_Piece,
                          B => Game_Board);
   
   Print_Board (Game_Board);
   Put_Line ("GAME OVER!");

end Main;
