package body Access_Type is

   -----------------------
   -- Number_Of_Members --
   -----------------------

   function Number_Of_Members (S : Set) return Natural is
      Current_Record : Set := S;
      Count : Natural := 0;
   begin
      while Current_Record /= null loop
         Count := Count + 1;
         Current_Record := Current_Record.Next;
      end loop;
      return Count;
   end Number_Of_Members;

   ---------------
   -- Is_Member --
   ---------------

   function Is_Member (S : Set; E : Integer) return Boolean is
      Current_Record : Set := S;
      Found : Boolean := False;
   begin
      while Current_Record /= null loop
         Found := Current_Record.Element = E;
         exit when Found;
         Current_Record := Current_Record.Next;
      end loop;
      return Found;
   end Is_Member;

   ----------------
   -- Get_Member --
   ----------------

   function Get_Member (S : Set; N : Positive) return Integer is
      Current_Record : Set := S;
   begin
      for I in 2 .. N loop
         Current_Record := Current_Record.Next;
      end loop;
      return Current_Record.Element;
   end Get_Member;

   ----------------
   -- Add_Member --
   ----------------

   procedure Add_Member (S : in out Set; E : Integer) is
   begin
      if not Is_Member (S, E) then
         S := new Set_Record'(E, S);
      end if;
   end Add_Member;

end Access_Type;
