with Ada.Containers.Vectors;
generic
   type Index_Type is range <>;
   type Element_Type is private;

   with function "=" (Left, Right : Element_Type) return Boolean is <>;

package My_Generic_Vectors
is
   subtype Extended_Index is Index_Type'Base
      range Index_Type'First - 1 ..
            Index_Type'Min (Index_Type'Base'Last - 1, Index_Type'Last) + 1;

   type Vector is private;

   Empty_Vector : constant Vector;

   function "&" (Left : Vector; Right : Element_Type) return Vector;

   function Element (V : Vector; I : Index_Type) return Element_Type;
   function First_Index (V : Vector) return Index_Type;
   function Last_Index  (V : Vector) return Extended_Index;
private
   package Vectors is new Ada.Containers.Vectors (Index_Type   => Index_Type,
                                                  Element_Type => Element_Type,
                                                  "="          => "=");
   type Vector is record
      Vec : Vectors.Vector;
   end record;

   Empty_Vector : constant Vector := (Vec => Vectors.Empty_Vector);
end My_Generic_Vectors;
