with Ada.Containers,
     Ada.Integer_Text_IO,
     Needed,
     My_Sets;
use Ada.Integer_Text_IO,
    Ada.Containers,
    Needed,
    My_Sets;
pragma Warnings (Off, Default_Width);
pragma Warnings (Off, Default_Base);
pragma Warnings (Off, "*has no effect");
procedure Use_My_Sets with
  SPARK_Mode,
  Global => (Default_Width, Default_Base)
is
   --  Reflexivity
   pragma Assert (for all E in Element_Type => Equivalent_Elements (E, E));

   -- Symmetry
   pragma Assert
     (for all E1 in Element_Type =>
        (for all E2 in Element_Type =>
             (if Equivalent_Elements (E1, E2) then
                     Equivalent_Elements (E2, E1))));

   -- Transitivity
   pragma Assert
     (for all E1 in Element_Type =>
        (for all E2 in Element_Type =>
             (for all E3 in Element_Type =>
                  (if Equivalent_Elements (E1, E2) and
                         Equivalent_Elements (E2, E3) then
                          Equivalent_Elements (E1, E2)))));

   Set_Size : constant Count_Type := Count_Type (Element_Type'Last);

   subtype My_Set is My_Sets.Set (Capacity => Set_Size,
                                  Modulus  => Default_Modulus (Set_Size));

   function Double_All (S : My_Set) return My_Set with
     Global => null,
     Pre  => (for all E of S => E <= 50),
     Post => (for all E of S => Contains (Double_All'Result, 2 * E));

   function Double_All (S : My_Set) return My_Set is
      R       : My_Set;
      Current : Cursor := First (S);
   begin
      Clear (R);
      while Has_Element (S, Current) loop
         pragma Loop_Invariant
           (Length (R) <= Length (First_To_Previous (S, Current))
            and then
              (for all Cu in First_To_Previous (S, Current) =>
                   Contains (R, 2 * Element (S, Cu))));
         Include (R, 2 * Element (S, Current));
         Next (S, Current);
      end loop;
      return R;
   end Double_All;

   Some_Elements : constant array (Positive range <>) of Element_Type :=
     (49, 1, 45, 32, 12, 37, 25, 4, 3, 14, 14, 12);

   The_Set : My_Set;

   My_Cursor : Cursor;

begin
   Clear (The_Set);
   for I in Some_Elements'Range loop
      Insert (The_Set, Some_Elements (I));
   end loop;
   The_Set := Double_All (The_Set);

   My_Cursor := First (The_Set);

   while My_Cursor /= No_Element loop
      pragma Warnings (Off);
      Put (Integer (Element (The_Set, My_Cursor)));
      My_Cursor := Next (The_Set, My_Cursor);
   end loop;
end Use_My_Sets;
