package body Init_Array with
  SPARK_Mode
is
   type Nat_Array is array (Positive range <>) of Natural;

   procedure Init_Simple (A : out Nat_Array) is
   begin
      for I in A'Range loop
         A (I) := 0;
      end loop;
   end Init_Simple;

   procedure Init_Simple_Agg (A : out Nat_Array) is
   begin
      A := (others => 0);
   end Init_Simple_Agg;

   procedure Init_Harder (A : out Nat_Array) is
   begin
      for I in A'Range loop
         A (I) := I;
      end loop;
   end Init_Harder;

   pragma Warnings (Off, """A"" might not be initialized in ""Init_Harder_Warn""");
   procedure Init_Harder_Warn (A : out Nat_Array) is
   begin
      pragma Warnings (Off, """A"" might not be initialized");
      for I in A'Range loop
         A (I) := I;
         pragma Loop_Invariant (for all J in A'First .. I => A (J) = J);
      end loop;
      pragma Warnings (On, """A"" might not be initialized");
   end Init_Harder_Warn;
   pragma Warnings (On, """A"" might not be initialized in ""Init_Harder_Warn""");

   procedure Dummy_Init (A : out Nat_Array);

   procedure Init_Harder_Dummy (A : out Nat_Array) is
   begin
      Dummy_Init (A);
      for I in A'Range loop
         A (I) := I;
         pragma Loop_Invariant (for all J in A'First .. I => A (J) = J);
      end loop;
   end Init_Harder_Dummy;

   procedure Dummy_Init (A : out Nat_Array) with
     SPARK_Mode => Off
   is
   begin
      null;
   end Dummy_Init;

end Init_Array;
