package body Odometer with
  SPARK_Mode,
  Refined_State => (State => (Concrete_Trip, Concrete_Total),
                    Factory_Resets => Reset_Count)
is
   pragma Warnings (Off, "is read but never assigned");
   Concrete_Total,
   Concrete_Trip : Natural;
   Reset_Count : Natural;

   -- As we have used a simple mapping between the abstract
   -- properties and concrete types,
   -- the definition of the functions relating the abstract view and the
   -- concrete view is simple:
   function Total return Natural is (Concrete_Total) with
      Refined_Global => Concrete_Total;
   function Trip return Natural is (Concrete_Trip) with
      Refined_Global => Concrete_Trip;

   procedure Zero_Trip with
      Refined_Global  => (Output => Concrete_Trip)
   is
   begin
      Concrete_Trip := 0;
   end Zero_Trip;

   procedure Increment with -- increment milage of odometer
     Refined_Global => (In_Out => (Concrete_Total, Concrete_Trip))
   is
      function Local_Inc (N : Natural) return Natural is
         (if N < Natural'Last then N + 1 else 0);
   begin
      Concrete_Trip := Local_Inc (Concrete_Trip);
      Concrete_Total := Local_Inc (Concrete_Total);
   end Increment;

   function Factory_Resets return Natural is (Reset_Count) with
     Refined_Global => Reset_Count;

begin
   pragma SPARK_Mode (Off);
   null;  -- Some mechanism for storing Concrete_Total and Reset_Count
end Odometer;
