package Odometer with
  SPARK_Mode,
  Abstract_State => (State, Factory_Resets),
  Initializes => (State, Factory_Resets)
is
   function Trip return Natural with -- number of miles so far on this trip.
      Global => State;
   function Total return Natural with -- total mileage of vehicle
      Global => State;

   procedure Zero_Trip with
      Global => (In_Out => State), -- In_Out because we do not want to reset Total
      Post    =>  Trip = 0 and Total = Total'Old;

   function Increment (N : Natural) return natural is
     (if N < Natural'Last then N + 1 else 0) with
     Convention => Ghost;
   procedure Increment with -- increment milage of odometer
     Global => (In_Out => State),
     Post => Trip = Increment (Trip'Old) and Total = Increment (Total'Old);

   function Factory_Resets return Natural with
     Global => Factory_Resets;
end Odometer;
