with Parent.Private_Child;
package body Parent with
SPARK_Mode,
  Refined_State => (State_1 => (Private_Child.Child_State, Body_State),
                    State_2 => Private_Child.N)
is
   Body_State : Natural := 0;

   function F return Natural is (Private_Child.N) with
     Refined_Global => Private_Child.N;

   procedure P (X : Natural) with
     Refined_Global => (Input  => Private_Child.Child_State,
                        In_Out => Body_State,
                        Output => Private_Child.N)
   is
   begin
      Private_Child.N := X;
      if Body_State <= Natural'Last - X then
         Body_State := Body_State + X;
         if Body_State <= Natural'Last - Private_Child.Get then
            Body_State := Body_State + Private_Child.Get;
         end if;
      end if;
   end P;

   procedure Reset (X : Natural) with
     Refined_Global => (Output => (Body_State,
                                   Private_Child.Child_State))
   is
   begin
      Private_Child.Set (X);
      Body_State := 0;
   end Reset;

end Parent;
