package body SHA_1_Binding is
   procedure SHA_1
     (Data    : in     Buffer_Type;
      Result  :    out Result_Type;
      Error   :    out Error_Code) with
     SPARK_Mode => Off
   is
      function Internal_SHA_1 -- function with side-effect
        (Data   : in      Buffer_Type; --  in by reference
         Result :     out Result_Type) -- out by reference
         return Int with
        Import,
        Convention => C,
        External_Name => "sha_1";

      Status_Code : Int;
   begin
      Status_Code  := Internal_SHA_1 (Data, Result);
      Error := (if Status_Code in Error_Code then Status_Code else 3);
   end SHA_1;

   function Is_SHA_1
     (Data   : Buffer_Type;
      Result : Result_Type) return Boolean is
     (Data = Data and Result = Result);

end SHA_1_Binding;
