with Interfaces.C;
use type Interfaces.C.int;
package SHA_1_Binding
with SPARK_Mode
is
   subtype Byte is Interfaces.C.unsigned_char;
   subtype Int is Interfaces.C.int;
   subtype Buffer_Index is Int range 1 .. 1024;
   subtype Result_Index is Int range 1 .. 20;
   -- Assume here obvious C-style data layout. Could force with rep
   -- clauses if necessary.
   type Buffer_Type is array (Buffer_Index) of Byte;
   type Result_Type is array (Result_Index) of Byte;

   subtype Error_Code is Int range 0 .. 3;

   function Is_SHA_1
     (Data   : Buffer_Type;
      Result : Result_Type) return Boolean with
     Convention => Ghost;

   procedure SHA_1 (Data    : in     Buffer_Type;
                    Result  :    out Result_Type;
                    Error   :    out Error_Code) with
     Post => (if Error = 0 then Is_SHA_1 (Data, Result));
end SHA_1_Binding;
