package body Simple_Sets.Model is

   --------------
   -- To_Model --
   --------------

   function To_Model (S : Set) return Model_Set is
      Model : Model_Set;
   begin
      for I in 1 .. Number_Of_Members (S) loop
         Insert (Container => Model.V,
                 Before    => Last_Index (Model.V) + 1,
                 New_Item  => Get_Member (S, I));
      end loop;
      return Model;
   end To_Model;

   function Add_Member (M : Model_Set; E : Integer) return Model_Set is
      Result : Model_Set := M;
   begin
      Insert (Container => Result.V,
              Before    => Last_Index (Result.V) + 1,
              New_Item  => E);
      return Result;
   end Add_Member;


--     ----------------
--     -- Equivalent --
--     ----------------
   function Equivalent (S : Set; M : Model_Set) return Boolean is
     (Number_Of_Members (S) = Natural (Length (M.V)) and
          (for all I in First_Index (M.V) .. Last_Index (M.V) =>
                  Is_Member (S, Element (M.V, I))));


--
--     function Equivalent (A, B : Model_Set) return Boolean is
--       (Length (A.V) = Length (B.V) and
--            (for all I in First_Index (A.V) .. Last_Index (A.V) =>
--                    Contains (B.V, Element (A.V, I))));

   function Preexisting_Members_Invariant (S : Set; M : Model_Set)
      return Boolean is
     (for all I in 1 .. Length (M.V) =>
           Is_Member (S, Element (Container => M.V,
                                  Index     => Extended_Index (I))));

   -----------------------
   -- Number_Of_Members --
   -----------------------

   function Number_Of_Members (M : Model_Set) return Natural is
      (Natural (Length (Container => M.V)));

   ---------------
   -- Is_Member --
   ---------------

   function Is_Member (M : Model_Set; E : Integer) return Boolean is
      (Contains (Container => M.V, Item => E));

   ----------------
   -- Get_Member --
   ----------------

   function Get_Member (M : Model_Set; N : Positive) return Integer is
      (Element (Container => M.V, Index => N));

end Simple_Sets.Model;
