with Simple_Sets,
     Simple_Sets.Model;
use Simple_Sets.Model;
package Simple_Sets.SPARK
with SPARK_Mode
is
   subtype Set is Simple_Sets.Set;

   function Number_Of_Members (S : Set) return Natural;

   function Is_Member (S : Set; E : Integer) return Boolean;

   function Get_Member (S : Set; N : Positive) return Integer with
     Pre => Number_Of_Members (S) /= 0;

   function Equivalent (A, B : Set) return Boolean is
     (Number_Of_Members (A) = Number_Of_Members (B) and
          (for all I in 1 .. Number_Of_Members (A) =>
                  Is_Member (B, Get_Member (A, I))));

   function "=" (Left, Right : Set) return Boolean renames Equivalent;

   procedure Add_Member (S : in out Set; E : Integer) with
     Post => Equivalent (S, Add_Member (To_Model (S)'Old, E));

--             Is_Member (S, E) and
--             Preexisting_Members_Invariant (S, To_Model (S)'Old)
--               (for all I in 1 .. Number_Of_Members (To_Model (S)'Old) =>
--                  Is_Member (To_Model (S), Get_Member (To_Model (S)'Old, I)))
--          and
--             ((not Is_Member (S, E)'Old and
--                  Number_Of_Members (S) = Number_Of_Members (S)'Old + 1)
--              or
--               (Number_Of_Members (S) = Number_Of_Members (S)'Old));

   procedure Destroy_Set (S : out Set) with
      Post => Number_Of_Members (S) = 0;

end Simple_Sets.SPARK;
