package body A_Stack with
  SPARK_Mode,
  Refined_State => (The_Stack => S)
is
   S : Stack_Type := (P => 0, V => (others => 0));

   function The_Stack return Stack_Type is (S) with Refined_Global => S;
   function Count (S : Stack_Type) return Natural is (Natural (S.P));
   function Element (S : Stack_Type; N : Positive) return Item is
     (S.V (N));

   function Is_Empty return Boolean is (S.P = 0) with
      Refined_Global => S;
   function Is_Full return Boolean is (S.P = Stack_Size) with
      Refined_Global => S;
   function Top return Item is (S.V (S.P)) with
      Refined_Global => S;

   procedure Push (It : in Item) with
     Refined_Global => (In_Out => S)
   is
   begin
      S.P := S.P + 1;
      S.V (S.P) := It;
   end Push;

   procedure Pop (It : out Item) with
     Refined_Global => (In_Out => S)
   is
   begin
      It := S.V (S.P);
      S.P := S.P - 1;
   end Pop;

end A_Stack;
