package body A_Stack_R with
  SPARK_Mode,
  Refined_State => (The_Stack => (P, V))
is
   subtype Stack_Pointer is Natural range 0 .. Stack_Size;
   subtype Index is Stack_Pointer range 1 .. Stack_Size;
   type Vector is array (Index) of Item;

   P : Stack_Pointer := 0;
   V : Vector := (others => 0);

   function Count return Natural is (P) with
     Refined_Global => P;

   function Is_Empty return Boolean is (P = 0) with
      Refined_Global => P;
   function Is_Full return Boolean is (P = Stack_Size) with
      Refined_Global => P;
   function Top return Item is (V (P)) with
      Refined_Global => (P, V);

   procedure Push (It : in Item) with
     Refined_Global => (In_Out => (P, V)),
     Refined_Post => V = V'Old'Update (P => It) and
                     Top = It and
                     Count = Count'Old + 1
   is
   begin
      P := P + 1;
      V (P) := It;
   end Push;

   procedure Pop (It : out Item) with
     Refined_Global => (In_Out => P,
                        Input  => V)
   is
   begin
      It := V (P);
      P := P - 1;
   end Pop;

end A_Stack_R;
