package A_Stack_R
with SPARK_Mode,
  Abstract_State => The_Stack,
  Initializes => The_Stack,
  Initial_Condition => Is_Empty
is
   Stack_Size : constant := 100;
   subtype Item is Integer range 0 .. 20;

   function Count return Natural with
     Global => The_Stack,
     Convention => Ghost;

   function Is_Empty return Boolean with
     Global => The_Stack,
     Post => Is_Empty'Result = (Count = 0);
   function Is_Full return Boolean with
     Global => The_Stack,
     Post => Is_Full'Result = (Count = Stack_Size);
   function Top return Item with
     Global => The_Stack,
     Pre => not Is_Empty or else Count > 0;

   procedure Push (It : in Item) with
     Global => (In_Out => The_Stack),
     Pre => not Is_Full or else Count < Stack_Size,
     Post => Top = It and
     Count = Count'Old + 1;
   procedure Pop (It : out Item) with
     Global => (In_Out => The_Stack),
     Pre => not Is_Empty or else Count > 0,
     Post => It = Top'Old and
             Count = Count'Old - 1;
end A_Stack_R;
