package body Disc_Stacks
with SPARK_Mode
is
   function Unchanged (Invariant_Part, New_Stack: Stack) return Boolean is
     (for all I in 1 .. Invariant_Part.P =>
              I in New_Stack.V'Range and then I in Invariant_Part.V'Range and then
              New_Stack.V (I) = Invariant_Part.V (I));

   function Count (S : Stack) return Natural is (Natural (S.P));

   function Is_Not_Empty (S : Stack) return Boolean is (S.P in 1 .. S.Stack_Size);
   function Is_Full (S : Stack) return Boolean is (S.P >= S.Stack_Size);
   function Top (S : Stack) return Item is (S.V (S.P));

   procedure Clear (S :    out Stack) is
   begin
      S.P := 0;
      S.V := (others => 0);
   end Clear;

   procedure Push (S : in out Stack; It : in     Item) is
   begin
      S.P := S.P + 1;
      pragma Assert (S.P in 1 .. S.Stack_Size);
      S.V (S.P) := It;
   end Push;

   procedure Pop (S : in out Stack; It :    out Item) is
   begin
      pragma Assert (S.P in 1 .. S.Stack_Size);
      It := S.V (S.P);
      S.P := S.P - 1;
   end Pop;

end Disc_Stacks;
