package body Stacks_R
with SPARK_Mode
is
   function Count (S : Stack) return Natural is (Natural (S.P));

   function Is_Empty (S : Stack) return Boolean is (S.P = 0);
   function Is_Full (S : Stack) return Boolean is (S.P = Stack_Size);
   function Top (S : Stack) return Item is (S.V (S.P));

   procedure Clear (S :    out Stack) is
   begin
      S.P := 0;
      S.V := (others => 0);
   end Clear;

   procedure Push (S : in out Stack; It : in     Item) with
     Refined_Post => S.V = S.V'Old'Update (S.P => It) and
     Top (S) = It and
     Count (S) = Count (S)'Old + 1
   is
   begin
      S.P := S.P + 1;
      S.V (S.P) := It;
   end Push;

   procedure Pop (S : in out Stack; It :    out Item) with
     Refined_Post => S.V = S.V'Old and
     It = Top (S)'Old and
     Count (S) = Count (S)'Old - 1
   is
   begin
      It := S.V (S.P);
      S.P := S.P - 1;
   end Pop;

end Stacks_R;
