with System.Storage_Elements;
package body Write_Only_And_Essential with
  SPARK_Mode,
  Refined_State => (State => (Offset, Test_Point))
is
   Offset : Integer := 0;
   Test_Point : Integer with
     Volatile,
     Async_Readers,
     Address => System.Storage_Elements.To_Address (16#FFFF_FFF0#);

   procedure Calibrate (Raw : in Integer; Cal : out Integer) with
     Refined_Global => (Input  => Offset,
                        Output => Test_Point)
   is
   begin
      Cal := Raw + Offset;
      Test_Point := Cal;
   end Calibrate;
begin
   pragma SPARK_Mode (Off);
   null;
end Write_Only_And_Essential;
